Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.Text

Namespace DAL
    Public Class SqlHelper

        Private Shared strConn As String

        Shared Sub New()
            strConn = ConfigurationManager.ConnectionStrings("ConnectionString").ConnectionString
        End Sub

        Public Shared Function ExecuteNonQuery(ByVal query As String) As Integer
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(query, cnn)
            cnn.Open()
            Dim retval As Integer = cmd.ExecuteNonQuery()
            cnn.Close()
            Return retval
        End Function

        Public Shared Function ExecuteNonQuery(ByVal query As String, ByVal params() As SqlParameter) As Integer
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(query, cnn)
            FillParameters(cmd, params)
            cnn.Open()
            Dim retval As Integer = cmd.ExecuteNonQuery()
            cnn.Close()
            Return retval
        End Function

        Public Shared Function ExecuteReader(ByVal sql As String) As SqlDataReader
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(sql, cnn)
            Return cmd.ExecuteReader(CommandBehavior.CloseConnection)
        End Function

        Public Shared Function ExecuteReader(ByVal sql As String, ByVal params() As SqlParameter) As SqlDataReader
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(sql, cnn)
            FillParameters(cmd, params)
            Return cmd.ExecuteReader(CommandBehavior.CloseConnection)
        End Function

        Public Shared Function ExecuteScalar(ByVal sql As String) As Object
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(sql, cnn)
            cnn.Open()
            Dim retval As Object = cmd.ExecuteScalar()
            cnn.Close()
            Return retval
        End Function

        Public Shared Function ExecuteScalar(ByVal sql As String, ByVal params() As SqlParameter) As Object
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(sql, cnn)
            FillParameters(cmd, params)
            cnn.Open()
            Dim retval As Object = cmd.ExecuteScalar()
            cnn.Close()
            Return retval
        End Function

        Public Shared Function ExecuteDataSet(ByVal sql As String) As DataSet
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(sql, cnn)
            Dim da As SqlDataAdapter = New SqlDataAdapter
            da.SelectCommand = cmd
            Dim ds As DataSet = New DataSet
            da.Fill(ds)
            Return ds
        End Function

        Public Shared Function ExecuteDataSet(ByVal sql As String, ByVal params() As SqlParameter) As DataSet
            Dim cnn As SqlConnection = New SqlConnection(strConn)
            Dim cmd As SqlCommand = New SqlCommand(sql, cnn)
            FillParameters(cmd, params)
            Dim da As SqlDataAdapter = New SqlDataAdapter
            da.SelectCommand = cmd
            Dim ds As DataSet = New DataSet
            da.Fill(ds)
            Return ds
        End Function

        Private Shared Sub FillParameters(ByVal cmd As SqlCommand, ByVal parameters() As SqlParameter)
            Dim i As Integer
            For i = 0 To parameters.Length - 1
                cmd.Parameters.Add(parameters(i))
            Next
        End Sub

    End Class
End Namespace